#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Tomato
#property indicator_color2 DodgerBlue
//---- input parameters
extern int     Per=9;
extern bool    UseSignal = true;
extern int     EMAPer=9;
extern double  t=0.5;

int CBars=500; 

double VidyaCMO[];
double VidyaCMOMA[];
double rsi,CMO,A;
//-------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,VidyaCMO);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,VidyaCMOMA);
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars;
   
   if(CBars==0)counted_bars=IndicatorCounted();
   if(CBars>0)counted_bars=CBars;
   if(counted_bars<0) return(-1);
   //if(counted_bars>0) counted_bars--;
   double vidprev;
//----
for(i=counted_bars;i>=0;i--)
{

rsi=iRSI(NULL,0,Per,PRICE_CLOSE,i);
CMO=MathAbs((2*rsi-100)/100);
A=t*CMO;
if(VidyaCMO[i]==EMPTY)vidprev=Close[i+1];
VidyaCMO[i]=A*Close[i]+(1-A)*vidprev;
vidprev=VidyaCMO[i];
}
if(UseSignal)
{
for(i=counted_bars;i>=0;i--)
{
VidyaCMOMA[i]=iMAOnArray(VidyaCMO,0,EMAPer,0,MODE_EMA,i);
}
}
//----
   return(0);
  }
//+------------------------------------------------------------------+